﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ATMS.Repository
{
    /// <summary>
    /// This is simply the contract or abstraction that we will be working with when interacting with its concrete implementation
    /// which will be the UnitOfWork object
    /// </summary>
    public interface IUnitOfWork
    {
        void Dispose();
        void Save();
        void Dispose(bool Disposing);
        IRepository<T> Repository<T>() where T : class;
    }
}
